#include "c_shared.h"

#include <exec/types.h>
#include <libraries/arpbase.h>  /* HAS! to be V39 or higher! */
#include <libraries/dosextens.h>

#include <packets.h>

#include <inline/exec.h>
#include <inline/arp.h>

/* 2.0 support */
#include "gcc:include20/utility/tagitem.h"
#include "gcc:include20/dos/dostags.h"
#include "gcc:include20/inline/dos.h"

extern int _dos20; /* set in crt0.c */

extern struct ArpBase *ArpBase;

#ifdef __GNUC__
#define alloca __builtin_alloca
#endif

/************************************************************************/
/*                                                                      */
/*    system() function.                                                */
/*                                                                      */
/************************************************************************/

int
system (cmd)
    char *cmd;
{
  int rc;
  int stack_size;
  struct CommandLineInterface *CLI;
  struct Process *me;

  /* sigsetmask() seems to be not enough when spawning processes.. */
  __suspend_signals ();
  me = (struct Process *)FindTask(0);
  CLI = BTOCPTR (me->pr_CLI);
  stack_size = CLI ? CLI->cli_DefaultStack : me->pr_StackSize;
  if (stack_size <= 4096) stack_size = 250000;

  /* limited support to allow starting of files in the current directory
   * with `./foo'. The better approach would use the __plock() trick to
   * parse the command, LoadSeg it. But then this approach would have to
   * do the whole redirection stuff on its own.. */
  while (*cmd == ' ' || *cmd == '\t') cmd++;
  while (cmd[0] == '.' && cmd[1] == '/') cmd += 2;

  /* before OS2.0, use ARP functions */
  if (! _dos20)
    {
      struct NewShell *nsh; /* erst ab Arp1.3 vorhanden !! */

      nsh = alloca (sizeof (*nsh));
      bzero (nsh, sizeof (*nsh));
      
      /* use same stacksize as parent process */
      nsh->nsh_StackSize = stack_size;
      nsh->nsh_Control = EXECUTE_ME;  /* BACKGROUND | EXECUTE */
        
      if (!ArpBase)
        {
          char *foo = "You need to open arp.library before using system()!\n";
          write (2, foo, strlen (foo));
          exit (20);
        }
      
      /* rc should be 0 if the generated pid was >= 0 */
      rc = ASyncRun ((UBYTE *)cmd, 0L, nsh) < 0;
    }
  else
    {
      struct TagItem tags [] = {
	/* a stack of 4K is generally ways too small.. */
	{ NP_StackSize, stack_size, },
	{ TAG_END, 0, }
      };

printf ("About to run >%s<.\n", cmd);
      rc = SystemTagList ((UBYTE *)cmd, tags);
printf ("which returned %d\n", rc);
    }

  __resume_signals ();

  return rc == 0 ? 0 : -1;
}
